'// SLABHIDDevice.bas : main Visual Basic module file for
'// SLABHIDDevice.dll Version 1.5
'/////////////////////////////////////////////////////////////////////////////

'/////////////////////////////////////////////////////////////////////////////
'// SLABHIDDevice Module
'/////////////////////////////////////////////////////////////////////////////

'/////////////////////////////////////////////////////////////////////////////
'// Definitions
'/////////////////////////////////////////////////////////////////////////////

' Return Codes
Public Const HID_DEVICE_SUCCESS As Byte = &H0
Public Const HID_DEVICE_NOT_FOUND As Byte = &H1
Public Const HID_DEVICE_NOT_OPENED As Byte = &H2
Public Const HID_DEVICE_ALREADY_OPENED As Byte = &H3
Public Const HID_DEVICE_TRANSFER_TIMEOUT As Byte = &H4
Public Const HID_DEVICE_TRANSFER_FAILED As Byte = &H5
Public Const HID_DEVICE_CANNOT_GET_HID_INFO As Byte = &H6
Public Const HID_DEVICE_HANDLE_ERROR As Byte = &H7
Public Const HID_DEVICE_INVALID_BUFFER_SIZE As Byte = &H8
Public Const HID_DEVICE_SYSTEM_CODE As Byte = &H9
Public Const HID_DEVICE_UNSUPPORTED_FUNCTION As Byte = &HA
Public Const HID_DEVICE_UNKNOWN_ERROR As Byte = &HFF

' Max number of USB Devices allowed
Public Const MAX_USB_DEVICES As Byte = 64

' Max number of reports that can be requested at time
Public Const MAX_REPORT_REQUEST_XP As Long = 512
Public Const MAX_REPORT_REQUEST_2K As Long = 200
Public Const DEFAULT_REPORT_INPUT_BUFFERS As Long = 0

' String Types
Public Const HID_VID_STRING As Byte = &H1
Public Const HID_PID_STRING As Byte = &H2
Public Const HID_PATH_STRING As Byte = &H3
Public Const HID_SERIAL_STRING As Byte = &H4
Public Const HID_MANUFACTURER_STRING As Byte = &H5
Public Const HID_PRODUCT_STRING As Byte = &H6

' String Lengths
Public Const MAX_VID_LENGTH As Long = 5
Public Const MAX_PID_LENGTH As Long = 5
Public Const MAX_PATH_LENGTH As Long = 260
Public Const MAX_SERIAL_STRING_LENGTH As Long = 256
Public Const MAX_MANUFACTURER_STRING_LENGTH As Long = 256
Public Const MAX_PRODUCT_STRING_LENGTH As Long = 256
Public Const MAX_INDEXED_STRING_LENGTH As Long = 256
Public Const MAX_STRING_LENGTH As Long = 260

'/////////////////////////////////////////////////////////////////////////////
'// SLABHIDDevice Functions
'/////////////////////////////////////////////////////////////////////////////

Public Declare Function HidDevice_GetNumHidDevices Lib "SLABHIDDevice.dll" (ByVal vid As Integer, ByVal pid As Integer) As Long
Public Declare Function HidDevice_GetHidString Lib "SLABHIDDevice.dll" (ByVal deviceIndex As Long, ByVal vid As Integer, ByVal pid As Integer, ByVal hidStringType As Byte, ByVal deviceString As String, ByVal deviceStringLength As Long) As Byte
Public Declare Function HidDevice_GetHidIndexedString Lib "SLABHIDDevice.dll" (ByVal deviceIndex As Long, ByVal vid As Integer, ByVal pid As Integer, ByVal stringIndex As Long, ByVal deviceString As String, ByVal deviceStringLength As Long) As Byte
Public Declare Function HidDevice_GetHidAttributes Lib "SLABHIDDevice.dll" (ByVal deviceIndex As Long, ByVal vid As Integer, ByVal pid As Integer, ByRef deviceVid As Integer, ByRef devicePid As Integer, ByRef deviceReleaseNumber As Integer) As Byte
Public Declare Sub HidDevice_GetHidGuid Lib "SLABHIDDevice.dll" (ByRef hidGuid As Any)
Public Declare Function HidDevice_GetHidLibraryVersion Lib "SLABHIDDevice.dll" (ByRef major As Byte, ByRef minor As Byte, ByRef release As Long) As Byte
Public Declare Function HidDevice_Open Lib "SLABHIDDevice.dll" (ByRef device As Any, ByVal deviceIndex As Long, ByVal vid As Integer, ByVal pid As Integer, ByVal numInputBuffers As Long) As Byte
Public Declare Function HidDevice_IsOpened Lib "SLABHIDDevice.dll" (ByVal device As Any) As Long
Public Declare Function HidDevice_GetHandle Lib "SLABHIDDevice.dll" (ByVal device As Any) As Long
Public Declare Function HidDevice_GetString Lib "SLABHIDDevice.dll" (ByVal device As Any, ByVal hidStringType As Byte, ByVal deviceString As String, ByVal deviceStringLength As Long) As Byte
Public Declare Function HidDevice_GetIndexedString Lib "SLABHIDDevice.dll" (ByVal device As Any, ByVal stringIndex As Long, ByVal deviceString As String, ByVal deviceStringLength As Long) As Byte
Public Declare Function HidDevice_GetAttributes Lib "SLABHIDDevice.dll" (ByVal device As Any, ByRef deviceVid As Integer, ByRef devicePid As Integer, ByRef deviceReleaseNumber As Integer) As Byte
Public Declare Function HidDevice_SetFeatureReport_Control Lib "SLABHIDDevice.dll" (ByVal device As Any, ByRef buffer As Byte, ByVal bufferSize As Long) As Byte
Public Declare Function HidDevice_GetFeatureReport_Control Lib "SLABHIDDevice.dll" (ByVal device As Any, ByRef buffer As Byte, ByVal bufferSize As Long) As Byte
Public Declare Function HidDevice_SetOutputReport_Interrupt Lib "SLABHIDDevice.dll" (ByVal device As Any, ByRef buffer As Byte, ByVal bufferSize As Long) As Byte
Public Declare Function HidDevice_GetInputReport_Interrupt Lib "SLABHIDDevice.dll" (ByVal device As Any, ByRef buffer As Byte, ByVal bufferSize As Long, ByVal numReports As Long, ByRef bytesReturned As Long) As Byte
Public Declare Function HidDevice_SetOutputReport_Control Lib "SLABHIDDevice.dll" (ByVal device As Any, ByRef buffer As Byte, ByVal bufferSize As Long) As Byte
Public Declare Function HidDevice_GetInputReport_Control Lib "SLABHIDDevice.dll" (ByVal device As Any, ByRef buffer As Byte, ByVal bufferSize As Long) As Byte
Public Declare Function HidDevice_GetInputReportBufferLength Lib "SLABHIDDevice.dll" (ByVal device As Any) As Integer
Public Declare Function HidDevice_GetOutputReportBufferLength Lib "SLABHIDDevice.dll" (ByVal device As Any) As Integer
Public Declare Function HidDevice_GetFeatureReportBufferLength Lib "SLABHIDDevice.dll" (ByVal device As Any) As Integer
Public Declare Function HidDevice_GetMaxReportRequest Lib "SLABHIDDevice.dll" (ByVal device As Any) As Long
Public Declare Function HidDevice_FlushBuffers Lib "SLABHIDDevice.dll" (ByVal device As Any) As Long
Public Declare Function HidDevice_CancelIo Lib "SLABHIDDevice.dll" (ByVal device As Any) As Long
Public Declare Sub HidDevice_GetTimeouts Lib "SLABHIDDevice.dll" (ByVal device As Any, ByRef getReportTimeout As Long, ByRef setReportTimeout As Long)
Public Declare Sub HidDevice_SetTimeouts Lib "SLABHIDDevice.dll" (ByVal device As Any, ByVal getReportTimeout As Long, ByVal setReportTimeout As Long)
Public Declare Function HidDevice_Close Lib "SLABHIDDevice.dll" (ByVal device As Any) As Byte
